#ifndef FONCTEURS_UTILITAIRES_H
#define FONCTEURS_UTILITAIRES_H

#include <iostream>
#include <string>

template <class T>
class Afficher
{
   std::ostream &m_o;
   std::string m_prefixe, m_suffixe;
public:
   Afficher (std::ostream &o,
             const std::string &prefixe = "",
             const std::string &suffixe = "")
      : m_o (o), m_prefixe (prefixe), m_suffixe (suffixe) { }
   void operator () (const T &e) { m_o << m_prefixe << e << m_suffixe; }
};

template <class T>
class AfficherPtr
{
   std::ostream &m_o;
   std::string m_prefixe, m_suffixe;
public:
   AfficherPtr (std::ostream &o,
                const std::string &prefixe = "",
                const std::string &suffixe = "")
      : m_o (o), m_prefixe (prefixe), m_suffixe (suffixe) { }
   void operator () (const T e) { m_o << m_prefixe << *e << m_suffixe; }
};

template <class T>
void ProgressionCirculaire (T &itt, T &bMin, T &bMax)
{
   itt ++; if (itt == bMax) itt = bMin;
}

template <class T> void Detruire (T p) { delete p; }

#endif // !defined FONCTEURS_UTILITAIRES_H
