#ifndef OUTILS_MATHS_H
#define OUTILS_MATHS_H

#include <cmath>

namespace OutilsMaths
{
   //
   // Tolrance pour fin de comparaison entre rels
   //
   const double TOLERANCE = 1.0e-7;
   //
   // Valeur de PI utilise
   //
   const double PI = 3.1415926535897932384626433832795;
   inline bool AngleAigu (const double Angle) { return Angle < PI / 2; }
   inline bool AngleObtu (const double Angle) { return Angle >= PI / 2; }

   inline bool Egaux(const double val1, const double val2)
   {
      return std::abs(val1 - val2) <= TOLERANCE;
   }
   template <class T>
   bool Entre (const T val, const T borne0, const T borne1)
   {
      return borne0 < val && val < borne1 || borne1 < val && val < borne0;
   }
}

#endif // defined OUTILS_MATHS_H
