#ifndef POLYGONE_H
#define POLYGONE_H

#include <vector>
#include "pt.h"

const float PI = 3.14159f;

class Triangle;

class Polygone
{
   enum { NB_PTS_MINIMUM= 3 };
   std::vector<pt> m_Points;
public:
   class PasAssezDePoints { };
   Polygone (const std::vector<pt> &v) throw (PasAssezDePoints)
      : m_Points (v)
   {
      if (m_Points.size () < NB_PTS_MINIMUM) throw PasAssezDePoints ();
   }
   Polygone (const Polygone &p) throw () : m_Points (p.m_Points)
   {
   }
   const std::vector<pt> & GetPoints () const throw () { return m_Points; }
   int CompterPrimitives () const throw ();
   //
   // Trianguler
   //
   std::vector<Triangle*> EnumererPrimitives () const throw ();
   bool PointDansPolygone (const pt &p) const throw ();
};

#endif // !defined POLYGONE_H
